Subject: Re: [RFC v2, net-next, PATCH 4/4] net/cpsw_switchdev: add switchdev mode of operation on cpsw driver

From: Ilias Apalodimas <[email-masked]>
Date: Thu, 14 Jun 2018 14:43:00 +0300

On Thu, Jun 14, 2018 at 01:39:58PM +0200, Jiri Pirko wrote:
> Thu, Jun 14, 2018 at 01:34:04PM CEST, [email-masked] wrote:
> >On Thu, Jun 14, 2018 at 01:30:28PM +0200, Jiri Pirko wrote:
> >> Thu, Jun 14, 2018 at 01:11:30PM CEST, [email-masked] wrote:
> >> 
> >> [...]
> >> 
> >> >@@ -2711,6 +2789,10 @@ static int cpsw_probe_dt(struct cpsw_platform_data *data,
> >> > 	if (of_property_read_bool(node, "dual_emac"))
> >> > 		data->switch_mode = CPSW_DUAL_EMAC;
> >> > 
> >> >+	/* switchdev overrides DTS */
> >> >+	if (IS_ENABLED(CONFIG_TI_CPSW_SWITCHDEV))
> >> >+		data->switch_mode = CPSW_SWITCHDEV;
> >> 
> >> So you force CPSW_SWITCHDEV mode if the CONFIG_TI_CPSW_SWITCHDEV is
> >> enabled. That does not sound right. I think that user should tell what
> >> mode does he want regardless what the kernel config is.
> >We discussed this during the V1 of the RFC. Yes it doesn't seem good, but the
> >device currently configures the modes using DTS (which is not correct). I choose
> >the .config due to that. I can't think of anything better, but i am open to
> >suggestions
> 
> Agreed that DTS does fit as well. I think that this might be a job for
> devlink parameters (patchset is going to be sent upstream next week).
> You do have 1 bus address for the whole device (both ports), right?
> 
Yes devlink sounds reasonable. I thyink there's only one bus for it, but then
again i am far from an expert on the hardware interrnals. Grygorii can correct
me if i am wrong.

Thanks for taking time to read this,
Ilias